#ifndef __Maze_Game_Controler_h__
#define __Maze_Game_Controler_h__

// The 4 directions
#define DirLeft		0xe04b
#define DirRight	0xe04d
#define DirUp		0xe048
#define DirDown		0xe050

// The 5 cell-types
#define CellGoods	0x1f
#define CellPath	0x20
#define CellWall	0x21
#define CellTele	0x40
#define CellDest	0x7f

// New types
typedef char* Str;

// Call this function to play the game!
bool playGame();

// Make 1 step toward direction dir. Returns whether stepped successfully.
bool step(int dir);
// The current position of the player
int posX();
int posY();

// Information of the maze map
int mapWidth();
int mapHeight();
Str* map();

// Look forward 1 step in direction dir. Return the maze cell at that direction.
char lookAt(int dir);

// Get the type this cell (pathway, wall, destination, goods, teleporter)
int cellType(char cellContent);

// Mahattan distance from current position to the destination
int toDestination();
// Mahattan distance to the destination, from the position of next step toward dir
int toDestination(int dir);

// Maximum number of steps you can make from now.
int timeLeft();

// Number of bucks you have collected so far.
int money();

// Update the status line
void setStatus(Str message);

#endif